var
   path = require('path'),
   requirejs = require('requirejs'),
   bodyParser = require('body-parser'),
   global = (function(){ return this || (0,eval)('this'); }()),
   requireJsConfig = require('./ext/requirejs/config.js');

global.requirejs = requirejs;

requirejs.config(requireJsConfig(__dirname, __dirname));

var exportsFunc = function(config){

   global.wsConfig = config.wsConfig;
   global.wsBindings = config.wsBindings;

   requirejs(path.join(__dirname, 'lib/core.js'));

   var $ws = global.$ws;

   return {
      ws: $ws,
      jsonrpcParser: function(req, res, next){
         res.json = (function(originalJson){
            return function(data){
               originalJson.apply(this, [{
                  "jsonrpc":"2.0",
                  "result": data,
                  "id":1,
                  "protocol":3
               }])
            }
         }(res.json));

         bodyParser.json({
            reviver: $ws.helpers.commonDataContainerReviver
         })(req, res, next);
      }
   };
};

module.exports = exportsFunc;